"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var css = require("classnames");
var config_1 = require("../config");
var redux_form_1 = require("redux-form");
var Input = (function (_super) {
    __extends(Input, _super);
    function Input() {
        _super.apply(this, arguments);
    }
    Input.prototype.render = function () {
        var type = this.props.type ? this.props.type : "text";
        return (React.createElement("div", {className: css("field", { inline: this.props.inline })}, 
            this.props.label ? React.createElement("label", null, config_1.default.i18n(this.props.label)) : null, 
            React.createElement("div", {className: css("ui", this.props.iconPosition, { icon: this.props.icon }, { right: this.props.rightLabel }, { labeled: this.props.leftLabel || this.props.rightLabel }, { search: this.props.search }, { disabled: this.props.disabled }, this.props.classes, "input")}, 
                this.props.leftLabel ? React.createElement("div", {className: "ui label"}, this.props.leftLabel) : null, 
                React.createElement("input", {ref: "input", type: type, className: this.props.inputClasses, placeholder: config_1.default.i18n(this.props.placeholder), onChange: this.props.input.onChange, value: this.props.input.value, onFocus: this.props.input.onFocus, onDragStart: this.props.input.onDragStart, onDrop: this.props.input.onDrop, onBlur: this.props.input.onBlur, readOnly: this.props.readOnly}), 
                this.props.icon ? React.createElement("i", {className: css(this.props.icon, "icon")}) : null, 
                this.props.rightLabel ? React.createElement("div", {className: "ui label"}, config_1.default.i18n(this.props.rightLabel)) : null), 
            this.props.meta.touched && this.props.meta.error && React.createElement("div", {className: "redux-form-error"}, this.props.meta.error)));
    };
    return Input;
}(React.Component));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = function (props) { return (React.createElement(redux_form_1.Field, __assign({name: props.name, component: Input}, props))); };
