"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var config_1 = require("../config");
var jss_1 = require('jss');
var textarea_1 = require("./textarea");
var styleSheet = jss_1.default.createStyleSheet({
    boxes: {
        display: 'table',
        width: '100%',
        height: '100%',
        '& .box': {
            'display': 'table-cell',
            'width': '50%',
            'max-width': '0'
        },
        '& .box1': {
            'padding-right': '6px',
        },
        '& .box2': {
            'padding-left': '6px',
            'border': '1px solid #ddd',
            'border-radius': '4px'
        },
        '& .preview': {
            height: '100%',
            overflow: 'auto',
            'box-sizing': 'content-box'
        }
    },
}).attach();
var jssClasses = styleSheet.classes;
var marked = null;
function renderMarkdown(value) {
    if (!marked) {
        marked = require('marked');
    }
    return marked(value);
}
var Markdown = (function (_super) {
    __extends(Markdown, _super);
    function Markdown() {
        _super.apply(this, arguments);
    }
    Markdown.prototype.previewHtml = function (e) {
        // get the value
        var value = e.currentTarget.value;
        // set the state and rerender
        this.previewDiv.innerHTML = renderMarkdown(value);
    };
    Markdown.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", {className: "field"}, 
            React.createElement("label", null, config_1.default.i18n(this.props.label)), 
            React.createElement("div", {className: jssClasses.boxes}, 
                React.createElement("div", {className: "box box1"}, 
                    React.createElement(textarea_1.default, __assign({onChange: this.previewHtml.bind(this)}, this.props, {label: ""}))
                ), 
                React.createElement("div", {className: "box box2"}, 
                    React.createElement("div", {className: "preview", ref: function (node) { _this.previewDiv = node; }})
                ))));
    };
    Markdown.prototype.componentDidMount = function () {
        this.previewDiv.innerHTML = renderMarkdown(this.props.defaultValue);
    };
    Markdown.prototype.componentDidUpdate = function () {
        this.previewDiv.innerHTML = renderMarkdown(this.props.defaultValue);
    };
    return Markdown;
}(React.Component));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Markdown;
