"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var css = require("classnames");
var redux_form_1 = require("redux-form");
var config_1 = require("../config");
var TextArea = (function (_super) {
    __extends(TextArea, _super);
    function TextArea() {
        _super.apply(this, arguments);
    }
    TextArea.prototype.render = function () {
        var _a = this.props, label = _a.label, classes = _a.classes, placeholder = _a.placeholder, rows = _a.rows, cols = _a.cols, inline = _a.inline, name = _a.name, input = _a.input, meta = _a.meta, readOnly = _a.readOnly, onChange = _a.onChange;
        return (React.createElement("div", {className: css("field", { inline: inline })}, 
            label ? React.createElement("label", null, config_1.default.i18n(label)) : null, 
            React.createElement("textarea", {className: classes, placeholder: config_1.default.i18n(placeholder), onChange: function (e) {
                input.onChange(e);
                if (onChange) {
                    onChange(e);
                }
            }, onFocus: input.onFocus, onDragStart: input.onDragStart, onDrop: input.onDrop, onBlur: input.onBlur, value: input.value, rows: rows, cols: cols, name: name, readOnly: readOnly}), 
            meta.touched && meta.error && React.createElement("div", {className: "redux-form-error"}, meta.error)));
    };
    return TextArea;
}(React.Component));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = function (props) { return (React.createElement(redux_form_1.Field, __assign({name: props.name, component: TextArea}, props))); };
